## minc 2.2.00

=== CMakeLists.txt ===
# CMakeFiles.txt for the MINC2 library
#
# Andrew Janke - a.janke@gmail.com
# Vladimir S. FONOV - vladimir.fonov@gmail.com

PROJECT(minc2)

SET(MINC2_PACKAGE_VERSION_MAJOR 2)
SET(MINC2_PACKAGE_VERSION_MINOR 2)
SET(MINC2_PACKAGE_VERSION_PATCH 00)
SET(PACKAGE "minc2")
SET(PACKAGE_BUGREPORT "a.janke@gmail.com")

SET(PACKAGE_NAME "minc2")
SET(PACKAGE_VERSION "${MINC2_PACKAGE_VERSION_MAJOR}.${MINC2_PACKAGE_VERSION_MINOR}.${MINC2_PACKAGE_VERSION_PATCH}")
SET(PACKAGE_STRING  "${PACKAGE_NAME} ${PACKAGE_VERSION}")
ENABLE_TESTING()
INCLUDE(CTest)

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

IF(MINC_TOOLKIT_BUILD)
  SET(MINC2_EXTERNALLY_CONFIGURED ON)
ENDIF(MINC_TOOLKIT_BUILD)

IF(NOT MINC2_EXTERNALLY_CONFIGURED)
  SET(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules")
  
  SET(CPACK_GENERATOR TGZ)
  SET(CPACK_PACKAGE_VERSION_MAJOR ${MINC2_PACKAGE_VERSION_MAJOR})
  SET(CPACK_PACKAGE_VERSION_MINOR ${MINC2_PACKAGE_VERSION_MINOR})
  SET(CPACK_PACKAGE_VERSION_PATCH ${MINC2_PACKAGE_VERSION_PATCH})
  
  OPTION(MINC2_BUILD_SHARED_LIBS "Build minc2 with shared libraries." OFF)
  
  INCLUDE(CPack)
  
  OPTION(MINC2_BUILD_V2                "Support minc2 file format" ON)
  OPTION(MINC2_BUILD_TOOLS             "Build minc tools (mincreshape,mincresample, etc)" ON)
  OPTION(MINC2_BUILD_CONVERTERS        "Build minc conversion programs (mnc2nii, nii2mnc , dcm2mnc...)" ON)
  OPTION(MINC2_BUILD_EZMINC            "Build C++ interface library EZminc" ON)
  OPTION(MINC2_BUILD_EZMINC_EXAMPLES   "Build EZminc examples" ON)
  
ENDIF(NOT MINC2_EXTERNALLY_CONFIGURED)

IF(MINC2_BUILD_V2 AND NOT MINC2_EXTERNALLY_CONFIGURED)
  IF(ITK_FOUND AND ITK_VERSION_MAJOR VERSION_EQUAL 4) # check if using ITK HDF5 library
    IF(ITKHDF5_LOADED)
      SET(USE_ITK_HDF5 ON)
    ELSE(ITKHDF5_LOADED)
      SET(USE_ITK_HDF5 OFF)
    ENDIF(ITKHDF5_LOADED)
  ELSE(ITK_FOUND AND ITK_VERSION_MAJOR VERSION_EQUAL 4) # check if using ITK HDF5 library
    SET(USE_ITK_HDF5 OFF)
  ENDIF(ITK_FOUND AND ITK_VERSION_MAJOR VERSION_EQUAL 4) # check if using ITK HDF5 library
ENDIF(MINC2_BUILD_V2 AND NOT MINC2_EXTERNALLY_CONFIGURED)

IF(MINC2_BUILD_SHARED_LIBS)
  SET(LIBRARY_TYPE SHARED)
  SET(LIBRARY_INSTALL LIBRARY)
ELSE(MINC2_BUILD_SHARED_LIBS)
  SET(LIBRARY_TYPE STATIC)
  SET(LIBRARY_INSTALL ARCHIVE)
ENDIF(MINC2_BUILD_SHARED_LIBS)


# external packages
IF(NOT MINC2_EXTERNALLY_CONFIGURED)
  FIND_PACKAGE(NETCDF REQUIRED)
ENDIF(NOT MINC2_EXTERNALLY_CONFIGURED)


IF(MINC2_BUILD_V2 AND NOT MINC2_EXTERNALLY_CONFIGURED)
  IF(USE_ITK_HDF5)
    SET(HDF5_INCLUDE_DIR "${ITKHDF5_INCLUDE_DIRS}/itkhdf5") # a hack?
    SET(HDF5_LIBRARY     ${ITKHDF5_LIBRARIES})
    SET(ZLIB_LIBRARY   ${ITKZLIB_LIBRARIES})
  ELSE(USE_ITK_HDF5)
    FIND_PACKAGE(ZLIB REQUIRED)
    FIND_PACKAGE(HDF5 REQUIRED)
  ENDIF(USE_ITK_HDF5)
  
  IF(ZLIB_FOUND)
    SET(HAVE_ZLIB 1)
  ELSE(ZLIB_FOUND)
    FIND_PACKAGE(ZLIB)
    IF(ZLIB_FOUND)
      SET(HAVE_ZLIB 1)
    ENDIF(ZLIB_FOUND)
  ENDIF(ZLIB_FOUND)
ENDIF(MINC2_BUILD_V2 AND NOT MINC2_EXTERNALLY_CONFIGURED)

# add for building relocatable library
IF(UNIX)
  SET(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -fPIC")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
ENDIF(UNIX)

# check for prereqs
INCLUDE(CheckFunctionExists)

CHECK_FUNCTION_EXISTS(mkstemp  HAVE_MKSTEMP)
CHECK_FUNCTION_EXISTS(tmpnam   HAVE_TMPNAM)
CHECK_FUNCTION_EXISTS(tempnam  HAVE_TEMPNAM)
CHECK_FUNCTION_EXISTS(strerror HAVE_STRERROR)
CHECK_FUNCTION_EXISTS(popen    HAVE_POPEN)
CHECK_FUNCTION_EXISTS(fork     HAVE_WORKING_FORK)
CHECK_FUNCTION_EXISTS(vfork    HAVE_WORKING_VFORK)
CHECK_FUNCTION_EXISTS(fdopen   HAVE_FDOPEN)
CHECK_FUNCTION_EXISTS(strdup   HAVE_STRDUP)
CHECK_FUNCTION_EXISTS(getpwnam HAVE_GETPWNAM) 
CHECK_FUNCTION_EXISTS(select   HAVE_SELECT)
CHECK_FUNCTION_EXISTS(strerror HAVE_STRERROR) 
CHECK_FUNCTION_EXISTS(sysconf  HAVE_SYSCONF)
CHECK_FUNCTION_EXISTS(system   HAVE_SYSTEM)

INCLUDE(CheckIncludeFiles)
CHECK_INCLUDE_FILES(float.h     HAVE_FLOAT_H)
CHECK_INCLUDE_FILES(sys/dir.h   HAVE_SYS_DIR_H)
CHECK_INCLUDE_FILES(sys/ndir.h  HAVE_SYS_NDIR_H)
CHECK_INCLUDE_FILES(sys/stat.h  HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILES(sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES(sys/wait.h  HAVE_SYS_WAIT_H)
CHECK_INCLUDE_FILES(values.h    HAVE_VALUES_H)
CHECK_INCLUDE_FILES(unistd.h    HAVE_UNISTD_H)
CHECK_INCLUDE_FILES(dirent.h    HAVE_DIRENT_H)
CHECK_INCLUDE_FILES(memory.h    HAVE_MEMORY_H)
CHECK_INCLUDE_FILES(stdlib.h    HAVE_STDLIB_H)
CHECK_INCLUDE_FILES(fcntl.h     HAVE_FCNTL_H)
CHECK_INCLUDE_FILES(dlfcn.h     HAVE_DLFCN_H)
CHECK_INCLUDE_FILES(vfork.h     HAVE_VFORK_H)
CHECK_INCLUDE_FILES(inttypes.h  HAVE_INTTYPES_H)
CHECK_INCLUDE_FILES(string.h    HAVE_STRING_H)
CHECK_INCLUDE_FILES(strings.h   HAVE_STRINGS_H)
CHECK_INCLUDE_FILES(pwd.h       HAVE_PWD_H)

ADD_DEFINITIONS(-DHAVE_CONFIG_H)

# aliases
SET(VERSION "${PACKAGE_VERSION}")

IF(MINC2_BUILD_EZMINC)
  set(MINC2_INCLUDE_DIRS_CONFIG    
    ${CMAKE_CURRENT_SOURCE_DIR}/ezminc
  )
  INCLUDE_DIRECTORIES(
    ${CMAKE_CURRENT_SOURCE_DIR}/ezminc
   )
ENDIF(MINC2_BUILD_EZMINC)

# netcdf and HDF5

IF(MINC2_BUILD_V2)
  FIND_PACKAGE(ZLIB REQUIRED)
  SET(MINC2 "1")
ELSE(BUILD_MINC2)
  SET(MINC2 "0")
ENDIF(MINC2_BUILD_V2)

# config files for build
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h @ONLY)

# others
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/epm-header.in ${CMAKE_CURRENT_BINARY_DIR}/epm-header)

# set the master INCLUDE directories
INCLUDE_DIRECTORIES(
   ${CMAKE_CURRENT_SOURCE_DIR}
   ${CMAKE_CURRENT_BINARY_DIR}
   ${CMAKE_CURRENT_SOURCE_DIR}/libsrc
   ${CMAKE_CURRENT_SOURCE_DIR}/volume_io/Include
   )

INCLUDE_DIRECTORIES( ${NETCDF_INCLUDE_DIR} )

IF(MINC2_BUILD_V2)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/libsrc2 )
ENDIF(MINC2_BUILD_V2)

# some variables
SET(minc1_LIB_SRCS
   libsrc/ParseArgv.c
   libsrc/dim_conversion.c
   libsrc/image_conversion.c
   libsrc/minc_convenience.c
   libsrc/minc_error.c
   libsrc/nd_loop.c
   libsrc/netcdf_convenience.c
   libsrc/time_stamp.c
   libsrc/value_conversion.c
   libsrc/voxel_loop.c
   libsrc/hdf_convenience.c
   libsrc/minc_compat.c
   libsrc/minc_simple.c
   libsrc/read_file_names.c
   )

SET(minc1_HEADERS
  libsrc/minc.h 
  libsrc/ParseArgv.h 
  libsrc/voxel_loop.h 
  libsrc/nd_loop.h
  libsrc/time_stamp.h
  libsrc/minc_compat.h
  volume_io/Include/volume_io.h
  libsrc/minc_simple.h
)

SET(minc2_LIB_SRCS
   libsrc2/convert.c
   libsrc2/datatype.c
   libsrc2/dimension.c
   libsrc2/free.c
   libsrc2/grpattr.c
   libsrc2/hyper.c
   libsrc2/label.c
   libsrc2/m2util.c
   libsrc2/record.c
   libsrc2/slice.c
   libsrc2/valid.c
   libsrc2/volprops.c
   libsrc2/volume.c
   )

SET(minc2_HEADERS
  libsrc2/minc2.h
)

# volume_io2
SET(volume_io_LIB_SRCS
   volume_io/Geometry/colour.c
   volume_io/Geometry/colour_def.c
   volume_io/Geometry/gaussian.c
   volume_io/Geometry/inverse.c
   volume_io/Geometry/newton.c
   volume_io/Geometry/points.c
   volume_io/Geometry/splines.c
   volume_io/Geometry/tensors.c
   volume_io/Geometry/transforms.c
   volume_io/MNI_formats/gen_xf_io.c
   volume_io/MNI_formats/gen_xfs.c
   volume_io/MNI_formats/grid_transforms.c
   volume_io/MNI_formats/mni_io.c
   volume_io/MNI_formats/tag_points.c
   volume_io/MNI_formats/thin_plate_spline.c
   volume_io/Prog_utils/alloc.c
   volume_io/Prog_utils/alloc_check.c
   volume_io/Prog_utils/arrays.c
   volume_io/Prog_utils/files.c
   volume_io/Prog_utils/print.c
   volume_io/Prog_utils/progress.c
   volume_io/Prog_utils/string.c
   volume_io/Prog_utils/time.c
   volume_io/Volumes/evaluate.c
   volume_io/Volumes/get_hyperslab.c
   volume_io/Volumes/input_free.c
   volume_io/Volumes/input_mnc.c
   volume_io/Volumes/input_volume.c
   volume_io/Volumes/multidim_arrays.c
   volume_io/Volumes/output_mnc.c
   volume_io/Volumes/output_volume.c
   volume_io/Volumes/set_hyperslab.c
   volume_io/Volumes/volume_cache.c
   volume_io/Volumes/volumes.c
)

SET(volume_io_HEADERS
    volume_io/Include/volume_io/alloc.h
    volume_io/Include/volume_io/arrays.h 
    volume_io/Include/volume_io/basic.h 
    volume_io/Include/volume_io/def_math.h 
    volume_io/Include/volume_io/files.h 
    volume_io/Include/volume_io/geom_structs.h 
    volume_io/Include/volume_io/geometry.h 
    volume_io/Include/internal_volume_io.h 
    volume_io/Include/volume_io/multidim.h 
    volume_io/Include/volume_io/progress.h 
    volume_io/Include/volume_io/string_funcs.h 
    volume_io/Include/volume_io/system_dependent.h 
    volume_io/Include/volume_io/transforms.h 
    volume_io/Include/volume_io/vol_io_prototypes.h 
    volume_io/Include/volume_io/volume.h 
    volume_io/Include/volume_io/volume_cache.h
)

SET(MINC2_LIBRARY minc)
SET(VOLUME_IO_LIBRARY volume_io)

SET(MINC2_LIBRARIES ${MINC2_LIBRARY} ${NETCDF_LIBRARY})

#SET(MINC2_DEPENDENCIES "")

IF(MINC2_BUILD_V2)

  INCLUDE_DIRECTORIES( ${HDF5_INCLUDE_DIR} )

  SET(minc_LIB_SRCS ${minc1_LIB_SRCS} ${minc2_LIB_SRCS})
  SET(minc_HEADERS ${minc1_HEADERS} ${minc2_HEADERS})
  SET(MINC2_LIBRARY minc2)
  SET(MINC2_LIBRARIES ${MINC2_LIBRARY} ${HDF5_LIBRARY} ${NETCDF_LIBRARY} ${ZLIB_LIBRARY}  m )
  SET(VOLUME_IO_LIBRARY volume_io2)
  
ELSE(MINC2_BUILD_V2)
  SET(minc_LIB_SRCS ${minc1_LIB_SRCS} )
  SET(minc_HEADERS ${minc1_HEADERS} ${minc2_HEADERS})
ENDIF(MINC2_BUILD_V2)


ADD_LIBRARY(${MINC2_LIBRARY} ${LIBRARY_TYPE} ${minc_LIB_SRCS} )
TARGET_LINK_LIBRARIES(${MINC2_LIBRARY} ${NETCDF_LIBRARY} ${HDF5_LIBRARY} ${ZLIB_LIBRARY} m )

ADD_LIBRARY(${VOLUME_IO_LIBRARY} ${LIBRARY_TYPE} ${volume_io_LIB_SRCS})
TARGET_LINK_LIBRARIES(${VOLUME_IO_LIBRARY} ${MINC2_LIBRARY})

SET_TARGET_PROPERTIES(${MINC2_LIBRARY}     PROPERTIES VERSION ${PACKAGE_VERSION} SOVERSION ${MINC2_PACKAGE_VERSION_MAJOR})
SET_TARGET_PROPERTIES(${VOLUME_IO_LIBRARY} PROPERTIES VERSION ${PACKAGE_VERSION} SOVERSION ${MINC2_PACKAGE_VERSION_MAJOR})

ADD_DEPENDENCIES(${VOLUME_IO_LIBRARY} ${MINC2_LIBRARY})

INSTALL(TARGETS ${MINC2_LIBRARY}     ${LIBRARY_INSTALL} DESTINATION lib)
INSTALL(TARGETS ${VOLUME_IO_LIBRARY} ${LIBRARY_INSTALL} DESTINATION lib)
INSTALL(FILES   ${minc_HEADERS}      DESTINATION  include  )
INSTALL(FILES   ${volume_io_HEADERS} DESTINATION include/volume_io)

IF(MINC2_BUILD_TOOLS)
  ADD_SUBDIRECTORY( progs )
ENDIF(MINC2_BUILD_TOOLS)

IF(MINC2_BUILD_CONVERTERS)
  ADD_SUBDIRECTORY( conversion )
ENDIF(MINC2_BUILD_CONVERTERS)

IF(MINC2_BUILD_EZMINC)
  ADD_SUBDIRECTORY( ezminc )
ENDIF(MINC2_BUILD_EZMINC)

# config for the build directory
set(MINC2_USE_FILE_CONFIG  ${CMAKE_CURRENT_BINARY_DIR}/UseMINC2.cmake)

set(MINC2_INCLUDE_DIRS_CONFIG
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/libsrc
  ${CMAKE_CURRENT_SOURCE_DIR}/volume_io/Include
)

IF(MINC2_BUILD_EZMINC)
  set(MINC2_INCLUDE_DIRS_CONFIG
      ${MINC2_INCLUDE_DIRS_CONFIG}
       ${CMAKE_CURRENT_SOURCE_DIR}/ezminc)
ENDIF(MINC2_BUILD_EZMINC)


IF(MINC2_BUILD_V2)
  set(MINC2_INCLUDE_DIRS_CONFIG
    ${MINC2_INCLUDE_DIRS_CONFIG}
    ${CMAKE_CURRENT_SOURCE_DIR}/libsrc2
  )
ENDIF(MINC2_BUILD_V2)

IF(MINC2_BUILD_EZMINC)
  SET(EZMINC_LIBRARIES minc_io ${MINC2_LIBRARIES})
ENDIF(MINC2_BUILD_EZMINC)

set(MINC2_LIBRARY_DIRS_CONFIG ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR}/ezminc)
set(MINC2_LIBRARIES_CONFIG ${MINC2_LIBRARIES})


configure_file(MINC2Config.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/MINC2Config.cmake @ONLY )

configure_file(UseMINC2.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/UseMINC2.cmake @ONLY)

# config for install dir
set(MINC2_USE_FILE_CONFIG "${CMAKE_INSTALL_PREFIX}/lib/UseMINC2.cmake")
set(MINC2_INCLUDE_DIRS_CONFIG ${CMAKE_INSTALL_PREFIX}/include )
set(MINC2_LIBRARY_DIRS_CONFIG ${CMAKE_INSTALL_PREFIX}/lib)

#fix for superbuild install
IF(SUPERBUILD_STAGING_PREFIX)

  STRING(REPLACE "${SUPERBUILD_STAGING_PREFIX}/" "" MINC2_INCLUDE_DIRS_CONFIG "${MINC2_INCLUDE_DIRS_CONFIG}")
  STRING(REPLACE "${SUPERBUILD_STAGING_PREFIX}/" "" MINC2_LIBRARY_DIRS_CONFIG "${MINC2_LIBRARY_DIRS_CONFIG}")

=== conversion/CMakeLists.txt ===
# CMakeFiles.txt for the MINC2 conversion progs
#
# Andrew Janke - a.janke@gmail.com

#LINK_DIRECTORIES()
LINK_LIBRARIES( ${MINC2_LIBRARIES})


ADD_DEFINITIONS(-DHAVE_CONFIG_H)


# conversion progs (and libraries)
INCLUDE_DIRECTORIES(Acr_nema)
ADD_LIBRARY(acr_nema STATIC 
   Acr_nema/acr_io.c
   Acr_nema/dicom_client_routines.c
   Acr_nema/dicom_network.c
   Acr_nema/element.c
   Acr_nema/file_io.c
   Acr_nema/globals.c
   Acr_nema/group.c
   Acr_nema/message.c
   Acr_nema/value_repr.c)

ADD_EXECUTABLE(dcm2mnc
   dcm2mnc/dcm2mnc.c
   dcm2mnc/dicom_to_minc.c
   dcm2mnc/siemens_to_dicom.c
   dcm2mnc/dicom_read.c
   dcm2mnc/minc_file.c
   dcm2mnc/progress.c
   dcm2mnc/string_to_filename.c)
TARGET_LINK_LIBRARIES(dcm2mnc acr_nema )

ADD_EXECUTABLE(ecattominc
   ecattominc/ecattominc.c
   ecattominc/insertblood.c
   ecattominc/ecat_file.c
   ecattominc/machine_indep.c
   )
ADD_EXECUTABLE(minctoecat
   minctoecat/minctoecat.c
   minctoecat/ecat_write.c
   minctoecat/machine_indep.c
   )

TARGET_LINK_LIBRARIES(minctoecat ${VOLUME_IO_LIBRARY} ${MINC2_LIBRARIES} m)


ADD_EXECUTABLE(mnc2nii
   nifti1/mnc2nii.c
   nifti1/nifti1_io.c
   nifti1/znzlib.c
   )
TARGET_LINK_LIBRARIES(mnc2nii ${VOLUME_IO_LIBRARY} ${MINC2_LIBRARIES} m)

ADD_EXECUTABLE(nii2mnc
   nifti1/nii2mnc.c
   nifti1/nifti1_io.c
   nifti1/znzlib.c
   )
TARGET_LINK_LIBRARIES(nii2mnc ${VOLUME_IO_LIBRARY} ${MINC2_LIBRARIES} m)

ADD_EXECUTABLE(upet2mnc
   micropet/upet2mnc.c
   )

IF(BUILD_MINC2)

ADD_EXECUTABLE(vff2mnc
   vff2mnc/vff2mnc.c
   )
INSTALL(TARGETS
   vff2mnc
   DESTINATION bin)

ENDIF(BUILD_MINC2)


# install progs
INSTALL(TARGETS
   dcm2mnc
   ecattominc
   minctoecat
   mnc2nii
   nii2mnc
   upet2mnc
   DESTINATION bin)

=== progs/CMakeLists.txt ===
# CMakeFiles.txt for the MINC2 progs
#
# Andrew Janke - a.janke@gmail.com

INCLUDE_DIRECTORIES(Proglib)

LINK_LIBRARIES( ${MINC2_LIBRARIES} )
ADD_DEFINITIONS(-DHAVE_CONFIG_H)

IF(NOT MINC2_EXTERNALLY_CONFIGURED)
  FIND_PACKAGE(BISON)
  FIND_PACKAGE(FLEX)
ENDIF(NOT MINC2_EXTERNALLY_CONFIGURED)

# all the progs
ADD_EXECUTABLE(invert_raw_image mincview/invert_raw_image.c)
ADD_EXECUTABLE(mincaverage mincaverage/mincaverage.c)
TARGET_LINK_LIBRARIES(mincaverage m)

IF(BISON_FOUND AND FLEX_FOUND)
  include_directories(${CMAKE_CURRENT_BINARY_DIR} minccalc)
  
  BISON_TARGET(gram ${CMAKE_CURRENT_SOURCE_DIR}/minccalc/gram.y ${CMAKE_CURRENT_BINARY_DIR}/gram.c COMPILE_FLAGS "--debug")
  FLEX_TARGET(lex ${CMAKE_CURRENT_SOURCE_DIR}/minccalc/lex.l ${CMAKE_CURRENT_BINARY_DIR}/lex.c  )
  #ADD_FLEX_BISON_DEPENDENCY(gram lex)

  ADD_EXECUTABLE(minccalc 
                  minccalc/minccalc.c
                  minccalc/eval.c
                  minccalc/ident.c
                  minccalc/node.c
                  minccalc/optim.c
                  minccalc/scalar.c
                  minccalc/sym.c
                  minccalc/vector.c
                  ${FLEX_lex_OUTPUTS}
                  ${BISON_gram_OUTPUTS}
                 )

  TARGET_LINK_LIBRARIES(minccalc ${FLEX_LIBRARIES} m)

  INSTALL( TARGETS minccalc  DESTINATION bin)

  include_directories(${CMAKE_CURRENT_BINARY_DIR} mincgen)
  BISON_TARGET(ncgentab ${CMAKE_CURRENT_SOURCE_DIR}/mincgen/ncgentab.y ${CMAKE_CURRENT_BINARY_DIR}/ncgentab.c)
  FLEX_TARGET(ncgenyy ${CMAKE_CURRENT_SOURCE_DIR}/mincgen/ncgenyy.l ${CMAKE_CURRENT_BINARY_DIR}/ncgenyy.c)

  ADD_EXECUTABLE(mincgen mincgen/main.c
                            ${BISON_ncgentab_OUTPUTS}
                            ${FLEX_ncgenyy_OUTPUTS}
                            mincgen/escapes.c
                            mincgen/genlib.c
                            mincgen/getfill.c
                            mincgen/init.c
                            mincgen/load.c)
  INSTALL( TARGETS mincgen    DESTINATION bin)

  TARGET_LINK_LIBRARIES(mincgen ${FLEX_LIBRARIES})

ENDIF(BISON_FOUND AND FLEX_FOUND)

ADD_EXECUTABLE(mincconcat mincconcat/mincconcat.c)
ADD_EXECUTABLE(mincconvert mincconvert/mincconvert.c)
ADD_EXECUTABLE(minccopy minccopy/minccopy.c)

ADD_EXECUTABLE(mincdump mincdump/mincdump.c
                            mincdump/vardata.c
                            mincdump/dumplib.c)
                            
ADD_EXECUTABLE(mincexample1 mincexample/mincexample1.c)
ADD_EXECUTABLE(mincexample2 mincexample/mincexample2.c)
ADD_EXECUTABLE(mincexpand mincexpand/mincexpand.c)
ADD_EXECUTABLE(mincextract mincextract/mincextract.c)
ADD_EXECUTABLE(mincinfo mincinfo/mincinfo.c)
ADD_EXECUTABLE(minclookup minclookup/minclookup.c)
TARGET_LINK_LIBRARIES(minclookup m)

ADD_EXECUTABLE(mincmakescalar mincmakescalar/mincmakescalar.c)
TARGET_LINK_LIBRARIES(mincmakescalar m)

ADD_EXECUTABLE(mincmakevector mincmakevector/mincmakevector.c)
ADD_EXECUTABLE(mincmath mincmath/mincmath.c)
TARGET_LINK_LIBRARIES(mincmath m)

ADD_EXECUTABLE(minc_modify_header minc_modify_header/minc_modify_header.c)

ADD_EXECUTABLE(mincresample mincresample/mincresample.c
                               mincresample/resample_volumes.c
                               Proglib/convert_origin_to_start.c)
TARGET_LINK_LIBRARIES(mincresample ${VOLUME_IO_LIBRARY} ${MINC2_LIBRARIES} m)

ADD_EXECUTABLE(mincreshape mincreshape/mincreshape.c
                              mincreshape/copy_data.c)

ADD_EXECUTABLE(mincstats mincstats/mincstats.c)
TARGET_LINK_LIBRARIES(mincstats m)

ADD_EXECUTABLE(minctoraw minctoraw/minctoraw.c)
ADD_EXECUTABLE(mincwindow mincwindow/mincwindow.c)


ADD_EXECUTABLE(mincmorph mincmorph/mincmorph.c
                         mincmorph/kernel_io.c
                         mincmorph/kernel_ops.c 
                         mincmorph/kernel_io.h 
                         mincmorph/kernel_ops.h )
TARGET_LINK_LIBRARIES(mincmorph ${VOLUME_IO_LIBRARY} ${MINC2_LIBRARIES} m)


ADD_EXECUTABLE(mincsample mincsample/mincsample.c
                mincsample/mt19937ar.c
                mincsample/mt19937ar.h )
TARGET_LINK_LIBRARIES(mincsample ${VOLUME_IO_LIBRARY} ${MINC2_LIBRARIES} m)

ADD_EXECUTABLE(rawtominc rawtominc/rawtominc.c
                            Proglib/convert_origin_to_start.c)
TARGET_LINK_LIBRARIES(rawtominc m)

ADD_EXECUTABLE(voxeltoworld coordinates/voxeltoworld.c)
TARGET_LINK_LIBRARIES(voxeltoworld ${VOLUME_IO_LIBRARY} ${MINC2_LIBRARIES} m)

ADD_EXECUTABLE(worldtovoxel coordinates/worldtovoxel.c)
TARGET_LINK_LIBRARIES(worldtovoxel ${VOLUME_IO_LIBRARY} ${MINC2_LIBRARIES} m)

ADD_EXECUTABLE(transformtags xfm/transformtags.c)
TARGET_LINK_LIBRARIES(transformtags ${VOLUME_IO_LIBRARY} ${MINC2_LIBRARIES} m)

ADD_EXECUTABLE(xfmconcat xfm/xfmconcat.c)
TARGET_LINK_LIBRARIES(xfmconcat ${VOLUME_IO_LIBRARY} ${MINC2_LIBRARIES} m)

ADD_EXECUTABLE(xfminvert xfm/xfminvert.c)
TARGET_LINK_LIBRARIES(xfminvert ${VOLUME_IO_LIBRARY} ${MINC2_LIBRARIES} m)

ADD_EXECUTABLE(mincblob mincblob/mincblob.c)
TARGET_LINK_LIBRARIES(mincblob ${VOLUME_IO_LIBRARY} ${MINC2_LIBRARIES} m)


# install progs
INSTALL(TARGETS
   invert_raw_image 
   mincaverage
   mincconcat
   mincconvert
   minccopy
   mincdump
#   mincexample1
#   mincexample2
   mincblob 
   mincexpand
   mincextract
   mincinfo
   minclookup
   mincmakescalar
   mincmakevector
   mincmath
   minc_modify_header
   mincresample
   mincreshape
   mincstats
   minctoraw
   mincwindow
   mincmorph
   mincsample
   rawtominc
   voxeltoworld
   worldtovoxel
   transformtags
   xfmconcat
   xfminvert
   DESTINATION bin)

# perl and shell scripts
INSTALL(PROGRAMS
   mincdiff/mincdiff  
   mincedit/mincedit  
   mincheader/mincheader  
   mincview/mincview
   PERMISSIONS 
    OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ  WORLD_EXECUTE WORLD_READ
   DESTINATION bin )

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/minchistory/minchistory.in ${CMAKE_CURRENT_BINARY_DIR}/minchistory @ONLY)
add_custom_target(minchistory chmod +x ${CMAKE_CURRENT_BINARY_DIR}/minchistory 
 DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/minchistory/minchistory.in)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/mincpik/mincpik.in ${CMAKE_CURRENT_BINARY_DIR}/mincpik @ONLY)
add_custom_target(mincpik chmod +x ${CMAKE_CURRENT_BINARY_DIR}/mincpik 
 DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/mincpik/mincpik.in)


INSTALL(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/minchistory
  PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ  WORLD_EXECUTE WORLD_READ
   DESTINATION bin )

INSTALL(PROGRAMS
  ${CMAKE_CURRENT_BINARY_DIR}/mincpik
  PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ  WORLD_EXECUTE WORLD_READ
   DESTINATION bin )

=== debian/changelog ===
minc (2.2.00-6) unstable; urgency=medium

  * Apply two patches fixing Mahem test issues.  Thanks to Martin
    Steghöfer <martin@steghoefer.eu>
    Closes: #716511, #716616
  * cme fix dpkg-control

 -- Andreas Tille <tille@debian.org>  Mon, 06 Oct 2014 09:49:50 +0200

minc (2.2.00-5) unstable; urgency=medium

  [ Gilles Filippini ]
  * rules: Support hdf5 1.8.13 new packaging layout.  Closes: #756684.

 -- Steve M. Robbins <smr@debian.org>  Sat, 02 Aug 2014 12:06:50 -0500

minc (2.2.00-4) unstable; urgency=medium

  * Apply patch provided by Alexander Ovchinnikov to build with clang
    (thanks to Alexander)
    Closes: 741744
  * cme fix dpkg-control
  * debian/copyright: DEP5

 -- Andreas Tille <tille@debian.org>  Mon, 05 May 2014 11:21:48 +0200

minc (2.2.00-3) unstable; urgency=low

  * patches/maxpathlen.patch: New.  Work around missing MAXPATHLEN on
    hurd.

 -- Steve M. Robbins <smr@debian.org>  Sat, 14 Sep 2013 00:39:06 -0500

minc (2.2.00-2) unstable; urgency=low

  * patches/pod_fix.diff: New.  Fix POD documentation to comply with
    stricter parsing of perl 5.18.  Closes: #719502.

  * rules: disable parallel build; causes tests to fail inexplicably.
  
 -- Steve M. Robbins <smr@debian.org>  Fri, 13 Sep 2013 23:22:53 -0500

minc (2.2.00-1) unstable; urgency=low

  * New upstream.
  * patches/hdfv2-fixes.patch: Remove.  Applied upstream.

  * patches/makefile.patch: New.  Fix build failure.
  * patches/acrnema-version.patch: New.  Add proper versioning to
    libacr_nema.

  * rules: Use "--with autoreconf" since new patches affect Makefile.am.

  * rules:  
  * control: SOVERSION bump to 3; new package name libminc2-3.

 -- Steve M. Robbins <smr@debian.org>  Sat, 13 Oct 2012 23:09:25 -0500

=== debian/control ===
Source: minc
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               autotools-dev,
               dh-autoreconf,
               libnetcdf-dev,
               zlib1g-dev,
               texlive-latex-base,
               libhdf5-dev
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/minc/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/minc/trunk/
Homepage: http://www.bic.mni.mcgill.ca/ServicesSoftware/HomePage

Package: minc-tools
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         netcdf-bin,
         libgetopt-tabular-perl,
         libtext-format-perl,
         imagemagick
Description: MNI medical image format tools
 This package contains tools to manipulate MINC files.
 .
 The Minc file format is a highly flexible medical image file format
 built on top of the NetCDF generalized data format. The format is
 simple, self-describing, extensible, portable and N-dimensional, with
 programming interfaces for both low-level data access and high-level
 volume manipulation. On top of the libraries is a suite of generic
 image-file manipulation tools. The format, libraries and tools are
 designed for use in a medical-imaging research environment: they are
 simple and powerful and make no attempt to provide a pretty interface
 to users.

Package: libminc2-3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: MNI medical image format library
 This package contains the libraries libminc2 and libvolume_io2.
 .
 The Minc file format is a highly flexible medical image file format.
 Minc version 1 is built on top of the NetCDF generalized data format. 
 Minc version 2 is built on top of the HDF data format.  This library
 handles both formats.  In each case the format is
 simple, self-describing, extensible, portable and N-dimensional, with
 programming interfaces for both low-level data access and high-level
 volume manipulation. On top of the libraries is a suite of generic
 image-file manipulation tools. The format, libraries and tools are
 designed for use in a medical-imaging research environment : they are
 simple and powerful and make no attempt to provide a pretty interface
 to users.

Package: libminc-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libminc2-3 (= ${binary:Version}),
         libnetcdf-dev,
         libhdf5-dev
Conflicts: libminc0-dev
Replaces: libminc0-dev
Description: MNI medical image format development environment
 This package contains the library and headers for libminc2 and
 libvolume_io2.
 .
 The Minc file format is a highly flexible medical image file format.
 Minc version 1 is built on top of the NetCDF generalized data format. 
 Minc version 2 is built on top of the HDF data format.  This library
 handles both formats.  In each case the format is
 simple, self-describing, extensible, portable and N-dimensional, with
 programming interfaces for both low-level data access and high-level
 volume manipulation. On top of the libraries is a suite of generic
 image-file manipulation tools. The format, libraries and tools are
 designed for use in a medical-imaging research environment : they are
 simple and powerful and make no attempt to provide a pretty interface
 to users.

=== debian/rules ===
#! /usr/bin/make -f

%:
	dh $@ --with autoreconf --with autotools_dev


ARCH  := $(shell dpkg-architecture -qDEB_BUILD_ARCH)
# Tests are buggy; disable test on sparc
ifeq ($(ARCH),sparc)
	DEB_BUILD_OPTIONS += nocheck
endif

ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial/libhdf5.so),)
  export DEB_CPPFLAGS_MAINT_APPEND := -I/usr/include/hdf5/serial
  export DEB_LDFLAGS_MAINT_APPEND := -Wl,-L/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial
endif

DEB_CONFIGURE_EXTRA_FLAGS = --enable-shared --enable-minc2 --enable-acr-nema CFLAGS="$(CFLAGS)"


override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CONFIGURE_EXTRA_FLAGS)

ps_docs = doc/prog_ref.ps doc/prog_guide.ps volume_io/Documentation/volume_io.ps

doc/prog_ref.ps doc/prog_guide.ps:
	$(MAKE) -C doc docs

volume_io/Documentation/volume_io.ps:
	$(MAKE) -C volume_io/Documentation docs

override_dh_install: $(ps_docs)
	# minc-tools
	rm -f debian/tmp/usr/bin/byte_swap
	rm -f debian/tmp/usr/bin/extract
	rm -f debian/tmp/usr/bin/acr_test
	rm -f debian/tmp/usr/bin/dicom_test
	dh_install -pminc-tools --autodest debian/tmp/usr/bin
	dh_install -pminc-tools --autodest debian/tmp/usr/share/man
	dh_link -pminc-tools \
		/usr/share/man/man1/voxeltoworld.1 \
		/usr/share/man/man1/worldtovoxel.1
	# libminc2-3
	dh_install -plibminc2-3 --autodest debian/tmp/usr/lib/*/lib*.so.*
	# libminc-dev
	dh_install -plibminc-dev --autodest debian/tmp/usr/lib/*/lib*.so
	dh_install -plibminc-dev --autodest  debian/tmp/usr/lib/*/lib*.a
	dh_install -plibminc-dev --autodest  debian/tmp/usr/include
	dh_installdocs -plibminc-dev $(ps_docs) debian/index.html
